package centij;

import classUtils.delegate.DelegateSynthesizerNew;
import gui.In;

import java.lang.reflect.Method;
import java.util.Vector;

/**
 * DocJava, Inc. User: lyon Date: Oct 11, 2004
 * Time: 3:50:49 PM
 */
public class Main {
    private StringBuffer sb = new StringBuffer();
    private Class c;
    private Object o;
    private String simpleClassName ;
    private String stubName ;
    private String serverWrapperName ;

    public static void main(String[] args) {
        new Main();
    }

    public Main() {
        In.message("Welcome to CentiJ");
        try {
            init();
        } catch (InstantiationException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        // first generate a proxy class.


        Vector v = new Vector();
        v.addElement(o);

        

        // then generate the interfaces to the proxy
        // finally generate the client class.

        //printMethods();
        //generateProxy();
        //System.out.println(this);
    }

    private void init()
            throws InstantiationException,
                   IllegalAccessException {
        c = In.getClassFromUser();
        simpleClassName = DelegateSynthesizerNew.getTypeName(c);
        stubName = simpleClassName +
                              "Stub";
        serverWrapperName = simpleClassName +
                                       "ServerWrapper";
        o = c.newInstance();
    }

    private void generateProxy() {
        addProxyClassName();
        addDelegateField();
        addConstructor();
    }

    private void addDelegateField() {
        println("private "+ c.getName() +" delegate;");
    }

    private void addConstructor() {
        println("public " + serverWrapperName +
                "(" +
                c.getName() +
                " delegate" +
                "){");
        println("this.delegate = delegate");
        println("}");
    }


    private void addProxyClassName() {
        println("// automatically generated by CentiJ on " +
                new java.util.Date());
        println(
                "import java.rmi.server.UnicastRemoteObject;");
        println("public class " +
                serverWrapperName +
                " extends UnicastRemoteObject implements " +
                stubName + " {");
    }

    public String toString() {
        return sb.toString();
    }

    private void println(Object o) {
        sb.append(o.toString() + '\n');
    }

    private void printMethods() {
        Method m[] = c.getMethods();
        for (int i = 0; i < m.length; i++)
            System.out.println(m[i]);
    }

}
