package centij;

//package net.compute;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class ReloadThread extends
        Thread {
    ObjectInputStream ois;
    ObjectOutputStream oos;

    ReloadThread(Socket s)
            throws IOException {
        // read the computable object from the
        // object input stream.
        // write the answer to the object output stream.
        oos =
                new ObjectOutputStream(
                        s.getOutputStream());

        ois =
                new ObjectInputStream(
                        s.getInputStream());
    }

    public void run() {
        try {
            // This should be the bytecodes for
            // a class!
            Object o = ois.readObject();

            if (o == null) {
                System.out.println("The Object is null");
                return;
            }

            if (!(o instanceof ByteCodeContainer)) {
                System.out.println("Bad object! this is not a RemoteClassLoader! we are here");
                return;
            }
            ByteCodeContainer
                    bcc = (ByteCodeContainer) o;

            oos.writeObject(bcc.compute());
            oos.close();
            ois.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}