package net.rmi.armi;
import net.rmi.utils.RmiRegistryUtils;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.registry.Registry;
public class RmiHelloServer {
    // before you run this program,
    // you must start the rmiregistry
    // from the classpath root.
    public static void main(String args[]){
        try {
            startServer();
        } catch (RemoteException e) {
            e.printStackTrace();
        } catch (java.net.MalformedURLException e) {
            e.printStackTrace();
        }
    }
       
    private static void startServer()
            throws RemoteException,
            java.net.MalformedURLException {
        println("starting server");
        RemoteHelloInterface ro = new RemoteHelloImplementation();
        println("binding remote instances");
        //Naming.rebind("RemoteHello",ro);
        Registry r = RmiRegistryUtils.getRegistry();
        r.rebind("RemoteHello",ro);
        println("waiting for invocations");
    }

    public static void println(Object o){
        System.out.println(o);
    }
}
